# https://docs.odriverobotics.com/v/0.5.4/getting-started.html

# autokey: terminal - set title os

dump_errors(odrv0)
odrv0.reboot()
odrv0.axis0.controller.input_pos # lese av pos



odrv0.axis0.requested_state = AXIS_STATE_FULL_CALIBRATION_SEQUENCE

odrv0.axis0.encoder.config.offset = 0 # i manuelt satt pos, resetter off

odrv0.axis0.motor.current_soft_max = 60
odrv0.axis0.motor.current_hard_max = 80

odrv0.axis0.motor.config.current_lim = 50 # Overordnet
odrv0.axis0.controller.config.vel_limit = 50 # Overordnet
odrv0.axis0.motor.config.torque_constant = 8.27/192 # 8.27 / 90 (8.27/KT)
odrv0.axis0.motor.config.motor_type = MOTOR_TYPE_HIGH_CURRENT
odrv0.axis0.encoder.config.cpr = 8192
odrv0.axis0.motor.config.calibration_current = 10 # under kalibrering
odrv0.axis0.encoder.config.use_index = True
odrv0.config.brake_resistance = 2
odrv0.axis0.motor.config.pole_pairs = 7 #20

odrv0.axis0.trap_traj.config.accel_limit = 45 # For trapes
odrv0.axis0.trap_traj.config.vel_limit = 35 # For trapes 
odrv0.axis0.trap_traj.config.decel_limit = 45 # For trapes
odrv0.axis0.controller.config.pos_gain = 180 # strammhet
odrv0.axis0.controller.config.vel_gain = 0.5 # turn/s
odrv0.axis0.controller.config.vel_integrator_gain = 0.1 # accelerasjon?
odrv0.axis0.controller.config.input_mode = INPUT_MODE_TRAP_TRAJ # God og lur å ha

odrv0.config.dc_max_negative_current = -1

odrv0.axis0.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL # Slår på 
'''
odrv0.axis0.requested_state = AXIS_STATE_FULL_CALIBRATION_SEQUENCE
odrv0.axis0.requested_state = AXIS_STATE_IDLE
odrv0.axis0.requested_state = AXIS_STATE_STARTUP_SEQUENCE
odrv0.axis0.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
odrv0.vbus_voltage
dump_errors(odrv0)
odrv0.reboot()

exec(open('r2.py').read())
'''

from datetime import datetime
import time
import math 
import os

kjor(os, datetime)

def kjor(os, datetime):
    odrv0.vbus_voltage
    odrv0.axis0.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
    f = open('work/tmp.cnt','r')
    lines = f.readlines()
    f.close()
    # os.popen("vlc vidZorg.mp4&")
    startSecLine = lines[0].split(":")
    startSec = int(float(startSecLine[0]))
    endSecLine = lines[len(lines)-1].split(":")
    endSec = int(float(endSecLine[0]))
    os.popen('mplayer -fs -ss ' + str(startSec) + ' -endpos ' +  str(endSec) + ' vidInp/vidZorg.mp4&')
    #os.popen(vlc --start-time' 0.1 --stop-time 2 vidInp/vidZorg.mp4&")
    time.sleep(0.8)
    dT = 2000 # samplings intervall us
    f = 0.1   # Hz for sinus eksemplet 
    periodNoNow = 0
    periodNoOld = 0 
    for sampNr in range(1, len(lines)):
        while periodNoNow == periodNoOld:
            tim = datetime.now()
            t = 60*1000000*tim.minute + 1000000*tim.second + tim.microsecond
            periodNoNow = int(t / dT)   
        periodNoOld = periodNoNow 
        s = lines[sampNr].split(":")  
        d = float(s[1])
        y = d / 4.0 + 0.2
        #print(s)
        odrv0.axis0.controller.input_pos = y
    odrv0.axis0.requested_state = AXIS_STATE_IDLE

#################################

odrv0.vbus_voltage
odrv0.axis0.requested_state = AXIS_STATE_CLOSED_LOOP_CONTROL
f = open('work/tmp.cnt','r')
lines = f.readlines()
f.close()
# os.popen("vlc vidZorg.mp4&")
startSecLine = lines[0].split(":")
startSec = int(float(startSecLine[0]))
endSecLine = lines[len(lines)-1].split(":")
endSec = int(float(endSecLine[0]))
time.sleep(0.8)
#os.popen('mplayer -fs -ss ' + str(startSec) + ' -endpos ' +  str(endSec) + ' vidInp/vidZorg.mp4&')
os.popen("vlc --start-time 3 --stop-time 6 --fullscreen vidInp/vidZorg.mp4&")
time.sleep(0.8)
dT = 2000 # samplings intervall us
f = 0.1   # Hz for sinus eksemplet 
periodNoNow = 0
periodNoOld = 0 
for sampNr in range(len(lines)):
    while periodNoNow == periodNoOld:
        tim = datetime.now()
        t = 60*1000000*tim.minute + 1000000*tim.second + tim.microsecond
        periodNoNow = int(t / dT)   
    periodNoOld = periodNoNow 
    s = lines[sampNr].split(":")  
    d = float(s[1])
    y = d / 4.0 + 0.2
    print(y)
    odrv0.axis0.controller.input_pos = y
    
odrv0.axis0.requested_state = AXIS_STATE_IDLE




use_index = true
pre_calibrated = false
encoder index search
encoder offset calibration
set pre_calibrated = True
save_configuration (forces reboot)

encoder index search
closed loop






















