Filters → Remeshing, Simplification and Reconstruction → Simplification: Quadric Edge Collapse Decimation





[F, V] = importSTLtoPolyTriMesh('grafikk/hjul.stl');
fig1; plotPoly(F, V, 'dark', 'edgeOff');

V(:,3) = -V(:,3);
m = min(V);
V = V - [0 0 m(3)];
m = max(V)-min(V);
V = V /m(3);
fig1; plotPoly(F, V, 'dark', 'edgeOff');


m = mean(V);

V(:,1) = V(:,1) - m(1);
V(:,2) = V(:,2) - m(2);


R = rotx(90);

R = rotz(180);
V = (R*V')';

Fhj = F;
Vhj = V;
save 'grafikk/pHjul.mat' Fhj Vhj


% BELG
load 'grafikk/pBelg.mat'; % Fbe, Vbe
m = max(Vbe)-min(Vbe);
Vbe = Vbe / m(3);
save 'grafikk/pBelg.mat' Fbe Vbe

fig3; plotPoly(Fbe, Vbe, 'dark', 'edgeOff');



% HJUL

[F, V] = importSTLtoPolyTriMesh('grafikk/hjul.stl');
fig3; plotPoly(F, V, 'dark', 'edgeOff');
R = rotx(90);
V = (R*V')';
m = max(V)-min(V);
V = V /m(3);

SWhjulAxDist = 35;
hjulAxDist = SWhjulAxDist/m(3);
hjulAxDist = 2.5 * hjulAxDist; % = 0.5898

Fhj = F;
Vhj = V;
save 'grafikk/pHjul.mat' Fhj Vhj

load 'grafikk/pHjul.mat'; % Fhj, Vhj
fig3; plotPoly(Fhj, Vhj, 'dark', 'edgeOff');


R = roty(-140);
Vhj = (R*Vhj')';

% STAG 1, origo nedre ax

[F, V] = importSTLtoPolyTriMesh('grafikk/stag1.stl');
V = -V;
fig3; plotPoly(F, V, 'dark', 'edgeOff');


m = max(V)-min(V);
V = V / m(3);

SWstagAxDist = 300;
stagAxDist = 3*SWstagAxDist/m(3); % 2.6318

Fst = F;
Vst = V;
save 'grafikk/pStag.mat' Fst Vst


% RAMME UNDER

[Fra, Vra] = importSTLtoPolyTriMesh('grafikk/rammeUnder.stl');
fig3; plotPoly(Fra, Vra, 'dark', 'edgeOff');
R = rotx(90);
Vra = (R*Vra')';
m = max(Vra)-min(Vra);
Vra = Vra /m(3);
m = min(Vra);
Vra = Vra - [0 0 m(3)];
fig3; plotPoly(Fra, Vra, 'dark', 'edgeOff');

save 'grafikk/pRammU.mat' Fra Vra